<?php

namespace App\Http\Controllers;

use App\Models\Habit;
use App\Models\Entry;
use Carbon\CarbonPeriod;
use Illuminate\Support\Carbon;

class DashboardController extends Controller
{
    public function index()
    {
        $start_date_range = new Carbon('3 months ago');
        $end_date_range = Carbon::today();
        $period = CarbonPeriod::create($start_date_range, $end_date_range);

        $dates = Array();
        forEach($period as $date) {
            $dates[] = $date->format('Y-m-d');
        }

        $entries = Habit::where('id', '1')->first()->entries;
        $entriesArr = array();

        forEach($dates as $date) {
           $entriesArr[] = 0;
            if ($entries->contains('date', $date)) {
                $entriesArr[] = 1;
            }
        }

        return view('dashboard', [
            'habits' => Habit::all(),
            'dates' => $dates,
            'entries' => $entriesArr,
            'habitName' => Habit::where('id', 1)->first()->name
        ]);
    }
}
