<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 dark:text-gray-200 leading-tight">
            {{ __('Habit Details') }}
        </h2>
    </x-slot>

    <div class="py-6">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white dark:bg-gray-800 overflow-hidden shadow-md sm:rounded-lg">
                <div class="p-6 text-gray-900 dark:text-gray-100">
                    {{ $habit->name }} <br> <br>

                    <form action="{{route("habits.edit", $habit)}}" method="get">
                        <x-primary-button>Edit</x-primary-button>
                    </form>
                </div>
            </div>
        </div>

        <div class="py-6">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <div class="bg-white dark:bg-gray-800 overflow-hidden shadow-md sm:rounded-lg">
                    <div class="p-6 text-gray-900 dark:text-gray-100">

                        <table class="table-auto text-left text-gray-700 dark:text-gray-400 border shadow rounded">
                            <thead class="text-gray-900 bg-gray-100 dark:bg-gray-700 dark:text-gray-200">
                            <tr>
                                <th scope="col" class="px-4 py-2">
                                    Value
                                </th>
                                <th scope="col" class="px-4 py-2">
                                    Date
                                </th>
                                <th scope="col" class="px-6 py-2">
                                    Note
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($entries as $entry)
                                <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700 even:bg-gray-50 hover:bg-gray-100 dark:hover:bg-gray-600">
                                    <td class="px-4 py-2">
                                        @if($habit->type === 'todo')
                                            <div class="mx-auto text-center">
                                                @if($entry->value == 0)
                                                    <input type="checkbox" name="" id="" disabled
                                                           class="rounded w-6 h-6 dark:bg-gray-900 border-gray-300 dark:border-gray-700 text-indigo-600 shadow-sm
                                                focus:ring-indigo-500 dark:focus:ring-indigo-600 dark:focus:ring-offset-gray-800 duration-300">
                                                @else
                                                    <input type="checkbox" name="" id="" disabled checked
                                                           class="rounded w-6 h-6 dark:bg-gray-900 border-gray-300 dark:border-gray-700 text-indigo-600 shadow-sm
                                                focus:ring-indigo-500 dark:focus:ring-indigo-600 dark:focus:ring-offset-gray-800 duration-300">
                                                @endif
                                            </div>
                                        @else
                                            {{$entry->value . $habit->suffix}}
                                        @endif

                                    </td>
                                    <td class="text-left px-4 py-2">
                                        {{$entry->date}}
                                    </td>
                                    <td class="px-4 py-2">
                                        {{$entry->note}}
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
</x-app-layout>
